## astmanproxy-1.30.0.tar.gz

=== Makefile ===
.EXPORT_ALL_VARIABLES:

OSARCH=$(shell uname -s)
OSREV=$(shell uname -r)

VERSION := 1.30.0
DESTDIR ?=
CONFDIR:=/etc/asterisk
CONFDIR_REAL := $(DESTDIR)/etc/asterisk
PERMDIR:=/etc/asterisk
PERMDIR_REAL := $(DESTDIR)/etc/asterisk
DISTDIR:=/var/www/html/astmanproxy

LIBDIR := $(DESTDIR)/usr/lib/astmanproxy
CONFFILE := astmanproxy.conf
PERMFILE := astmanproxy.users

CC := gcc
INCLUDES :=
PREFIX:= /usr/local
BINDIR := $(DESTDIR)$(PREFIX)/sbin

# For compilation dependencies
MODS := astmanproxy config config_perms common proxyfunc log ssl md5 crypt_blowfish crypt_gensalt wrapper
HANDLERS := xml standard csv http
SOBJS := $(HANDLERS:%=%.so)
LIBS := -lssl

# Add -g below for debug/GDB symbols
CFLAGS:=-Wall -O2 -D_REENTRANT -D_GNU_SOURCE -fPIC

ifeq (${OSARCH},Darwin)  
  LIBS+=-lresolv
  CFLAGS+=-D__Darwin_ -Iquotesrc/include
  BINDIR=/opt/sbin
  LIBDIR=/opt/lib/astmanproxy
  CONFDIR=/opt/etc/asterisk
  CONFDIR_REAL=/opt/etc/asterisk
  PERMDIR=/opt/etc/asterisk
  PERMDIR_REAL=/opt/etc/asterisk
  LOGDIR=/opt/log/asterisk
  CERTDIR := /opt/lib/asterisk/certs
  ifeq (${OSREV},7.9.0)
    OBJS+=poll.o dlfcn.o
  endif
  ASTLINK=-Wl,-force_flat_namespace,-dynamic
  SOLINK=-dynamic -bundle -undefined suppress -force_flat_namespace
  MKTEMP=/usr/bin/mktemp
else
  #These are used for all but Darwin
  #CFLAGS+=-I-
  CFLAGS+=-iquote$(shell pwd)/src/include
  LIBS+=-ldl -pthread
  ASTLINK=-Wl,-E
  SOLINK=-shared -Xlinker -x
  LOGDIR=/var/log/asterisk   
  CERTDIR := /var/lib/asterisk/certs
  MKTEMP=/bin/mktemp
endif

CFLAGS+=-Isrc/include -I/usr/include/openssl

MODDIR := $(LIBDIR)/modules
DEFINES:='-DPROXY_VERSION="$(VERSION)"' '-DCDIR="$(CONFDIR)"' '-DCFILE="$(CONFFILE)"'
DEFINES+='-DMDIR="$(MODDIR)"' '-DPDIR="$(PERMDIR)"' '-DPFILE="$(PERMFILE)"'

PROXYCERT := $(CERTDIR)/proxy-server.pem
PROXYSSLCONF := $(CONFDIR)/proxy-ssl.conf

CFLAGS += $(DEFINES)

OBJS += $(MODS:%=%.o)
CONF_TARGET:= $(CONFDIR_REAL)/$(CONFFILE)
PERM_TARGET:= $(PERMDIR_REAL)/$(PERMFILE)
VPATH = src


# For printing only
SRCS := $(MODS:%=%.c)
HDRS := astmanproxy.h

all: astmanproxy cert

astmanproxy: $(OBJS) $(SOBJS)
	$(CC) $(CFLAGS) -o $@ $(ASTLINK) $(OBJS) $(LIBS)

$(OBJS): %.o: %.c
	$(CC) $(CFLAGS) $(INCLUDES) -c -o $@ $<

$(SOBJS): %.so: %.o
	$(CC) $(SOLINK) $< -o $@

SERIAL=`date "+%Y%m%d%H%M%S"`

cert:
	if [ ! -f $(PROXYCERT) ]; then      \
		umask 77 ; \
                PEM1=`$(MKTEMP) /tmp/openssl.XXXXXX` ; \
                PEM2=`$(MKTEMP) /tmp/openssl.XXXXXX` ; \
		if [ ! -f $(PROXYSSLCONF) ]; then \
			install ./configs/ssl.conf $(PROXYSSLCONF); \
		fi; \
		/usr/bin/openssl req $(UTF8) -newkey rsa:1024 -keyout $$PEM1 -nodes -x509 -days 365 -out $$PEM2 -set_serial $(SERIAL) -config $(PROXYSSLCONF) ; \
                mkdir -p $(CERTDIR); \
                cat $$PEM1 >  $(PROXYCERT) ; \
                echo ""    >> $(PROXYCERT) ; \
                cat $$PEM2 >> $(PROXYCERT) ; \
                rm $$PEM1 $$PEM2; \
	fi

certificate:
	createcert="1"; \
	if [ -f $(PROXYCERT) ]; then      \
                echo -n "The certificate already exists, Do you really want to create new one(yes/no)?"; \
                read answer;  \
                if [ "$$answer" = "yes" ]; then \
                        echo "I am creating a new certificate, Old one is copied as server.pem.old ";\
                        sudo cp /var/lib/asterisk/certs/server.pem /var/lib/asterisk/certs/server.pem.old; \
                elif [ "$$answer" = "no" ]; then \
                        echo "Certificate already exists, I am not creating a new certificate,";\
                        createcert="0"; \
                else \
                        echo "You need to enter either yes or no"; \
                        createcert="0"; \
                fi; \
        fi; \
        if [ "$$createcert" = "1" ]; then  \
		umask 77 ; \
                PEM1=`$(MKTEMP) /tmp/openssl.XXXXXX` ; \
                PEM2=`$(MKTEMP) /tmp/openssl.XXXXXX` ; \
		if [ ! -f $(PROXYSSLCONF) ]; then \
			install ./configs/ssl.conf $(PROXYSSLCONF); \
		fi; \
		/usr/bin/openssl req $(UTF8) -newkey rsa:1024 -keyout $$PEM1 -nodes -x509 -days 365 -out $$PEM2 -set_serial $(SERIAL) -config $(PROXYSSLCONF) ; \
                mkdir -p $(CERTDIR); \
                cat $$PEM1 >  $(PROXYCERT) ; \
                echo ""    >> $(PROXYCERT) ; \
                cat $$PEM2 >> $(PROXYCERT) ; \
                rm $$PEM1 $$PEM2; \
	fi


install: uninstall all
	install -d $(BINDIR)
	install astmanproxy $(BINDIR)
	install -d $(LIBDIR)
	install -d $(MODDIR)
	install $(SOBJS) $(MODDIR)
	install -d $(CONFDIR_REAL)
	if [ ! -f $(CONF_TARGET) ]; then \
		install ./configs/$(CONFFILE) $(CONF_TARGET); \
	fi
	if [ ! -f $(PERM_TARGET) ]; then \
		install ./configs/$(PERMFILE) $(PERM_TARGET); \
	fi
	@echo "Installation Complete!"

uninstall:
	rm -f $(BINDIR)/astmanproxy
	cd $(MODDIR); rm -f $(SOBJS)
	@echo "Successfully uninstalled!"

dist: clean
	rm -rf /tmp/astmanproxy-${VERSION}*; \
	cp -R . /tmp/astmanproxy-${VERSION}; \
	cd /tmp; tar czf /tmp/astmanproxy-${VERSION}-`date +%Y%m%d-%H%M`.tgz astmanproxy-${VERSION}; \
        /usr/bin/scp /tmp/astmanproxy-${VERSION}-*.tgz root@www.popvox.com:$(DISTDIR); \
	/usr/bin/ssh -lroot www.popvox.com "ln -sf $(DISTDIR)/astmanproxy-${VERSION}-*.tgz $(DISTDIR)/astmanproxy-latest.tgz"

clean:
	rm -f *.o *.so core *~ astmanproxy proxy-server.pem;

print:
	more Makefile $(HDRS) $(SRCS) | enscript -Ec -2r -j; exit 0
	@echo "Printing Complete!"

love:
	@echo "Here?  Now?"

# DO NOT DELETE

=== debian/changelog ===
astmanproxy (1.26) unstable; urgency=low

   * Include MANY fixes roll-up from OOB development.
   * Change sessionlock from MUTEX to RWLOCK
   * Add several RDLOCK cases to prevent segfaults on connection close
   * Include latest "Newstate" with packet replay code.
   * Fix autofilter option for ActionID filtering.
   * Fix replay filtering. Dial cmd seems to have changed.
   * Fix buffer code to handle v.v.v.long lines on input.
   * Additional bounds checking on MAX_HEADERS to try and
     catch a core dump.
   * New FILT_BRIONLY and FILT_XFRONLY rules
   * Clean up server connection buffer before trying
     to connect.
   * Cancel threads before cleaning up their memory.
   * Increase the input buffer and optimise how the buffer is managed
   * Very busy systems can get backlogged on read buffers
     Try to resolve this by polling for new data on every read.
 
 -- Steve Davies <steved@ipcortex.co.uk>  Wed,  4 Apr 2012 14:54:46 +0100

astmanproxy (1.23.2) unstable; urgency=low

  * Improved I/O for very busy systems.
  * Massive performance boost - No need to bzero quite so much.
  * Clean out server buffers before re-opening.
  * Shutdown tries to nicely clean up threads.
  * New forcebanner option to set the initial banner output.
  * Attempt to handle quoted values in config file.
  * Matching on context is now correctly case-sensitive.

 -- Steve Davies <steved@ipcortex.co.uk>  Tue, 24 May 2011 12:32:22 +0100

astmanproxy (1.23.1) unstable; urgency=low

  * Segfault fix in standard.so
  * 100% CPU usage fix in httpd.so
  * New Autofilter mechanism added
  * Version number bumped to 1.23
  * Correct build deps in debian package info (fixed by nud)

 -- Steve Davies <steved@ipcortex.co.uk>  Fri, 27 Feb 2009 14:40:04 +0000

astmanproxy (1.21.90) unstable; urgency=low

  * Correcting the attribution in this file as it was never
    intended to be published.
  * Update code to very latest GIT based code with all
    contributions merged.
  * NOTE: This is effectively 1.22rc1

 -- Steve Davies <steved@ipcortex.co.uk>  Fri, 25 Jul 2008 14:34:15 +0100

astmanproxy (1.21-4) unstable; urgency=low

  * Bug fix update to 1.21e

 -- Steve Davies <steved@ipcortex.co.uk>  Wed, 31 Mar 2008 12:32:14 +0100

astmanproxy (1.21-3) unstable; urgency=low

  * Enhance and fix the filtering code to remember NewChannel events in
    case they are needed later

 -- Steve Davies <steved@ipcortex.co.uk>  Wed, 23 Jan 2008 16:51:56 +0000

astmanproxy (1.21-2) unstable; urgency=low

  * Apply 1.21d patch to source tree

 -- Steve Davies <steved@ipcortex.co.uk>  Wed, 23 Jan 2008 16:51:56 +0000

astmanproxy (1.21-1) unstable; urgency=low

  * Initial IPCortex build

 -- Steve Davies <steved@ipcortex.co.uk>  Tue, 11 Sep 2007 18:03:17 +0100

astmanproxy (1.0-1) unstable; urgency=low

  * Initial Release.

 -- Tzafrir Cohen <tzafrir.cohen@xorcom.com>  Tue,  7 Jun 2005 20:27:34 +0300

=== debian/control ===
Source: astmanproxy
Section: unknown
Priority: extra
Maintainer: Steve Davies <steved@ipcortex.co.uk>
Build-Depends: build-essential, debhelper (>= 5), libssl-dev
Standards-Version: 3.7.2

Package: astmanproxy
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Proxy daemon for Asterisk Manager Protocol
 Proxy daemon for Asterisk Manager Protocol. Its primary purpose is
 to offload the use of many threads to handle multiple AMP connections
 into a far more lightweight external daemon to improve stability and
 scaleability. It also adds authentication, filtering, and multi-server
 support.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

MAKE += PREFIX=/usr


CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.

	touch configure-stamp


build: build-stamp

build-stamp: configure-stamp 
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE)
	#docbook-to-man debian/astmanproxy.sgml > astmanproxy.1

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	# Add here commands to clean up after the build process.
	-$(MAKE) clean

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	# Add here commands to install the package into debian/astmanproxy.
	$(MAKE) install DESTDIR=$(CURDIR)/debian/astmanproxy


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples configs/astmanproxy.conf
#	dh_install
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman debian/astmanproxy.1
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_python
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
